freeze;


intrinsic IsIsotropic2(a1::RngIntElt, a2::RngIntElt) -> BoolElt, ModTupRngElt
{ Returns whether the binary quadratic form is isotropic over rationals 
 and isotropic vector with integral coordinates if so }

  // solve trivial case: zero occures on diagonal
  if (a1 eq 0) then
    return true, Vector([1,0]);
  elif (a2 eq 0) then
    return true, Vector([0,1]);
  end if;

  Is, root := IsSquare(-a2/a1);
  if Is then
    return true, Vector([Numerator(root), Denominator(root)]);
  else
    return false, _; 
  end if;
end intrinsic;


intrinsic IsIsotropic2(QF_M::AlgMatElt) -> BoolElt, ModTupRngElt
{ Returns whether the binary quadratic form is isotropic over rationals 
 and isotropic vector with integral coordinates if so }

  require IsSymmetric(QF_M): "Symmetric matrix required.";
  require NumberOfRows(QF_M) eq 2: "2 x 2 matrix required.";

  QF_M1, T, rank := OrthogonalizeGram(QF_M);

  b,v := IsIsotropic2(QF_M1[1][1], QF_M1[2][2]);
  if b then
    return true, v * T;
  end if;
  return false, _;

end intrinsic;


